
__author__="Austin"
__date__ ="$30-Aug-2009 5:53:42 PM$"

from tile import TileSprite
import pygame
from pygame.locals import *

class Level:
    def __init__(self, x, y):
        width = 20
        height = 15
        self.spflag = 0
        self.tiles = []
        self.tiledata = []
        self.x = x
        self.y = y
        self.img = TileSprite('pemptile.png', 16, 16, 4, 8, (0, 162, 152))
        for i in range(0, width):
            self.tiles.append([])
            self.tiledata.append([])
            for j in range(0, height):
                self.tiles[i].append(0)
                self.tiledata[i].append(0)

    def addsq(self, x, y, w, h):
        
        for i in range(x, x + w):
            for j in range(y, y + h):

                if i >= 0 and i <= 19:
                    if j >= 0 and j <= 14:
                        self.tiles[i][j] = 1
                        

    def has(self, x, y):
        
        if x >= 0 and x <= 19:
            if y >= 0 and y <= 14:
                return self.tiles[x][y]
            return 0
        return 0

    def get_tiledata(self, x, y):
        if x >= 0 and x <= 19:
            if y >= 0 and y <= 14:
                return self.tiledata[x][y]
            return 0
        return 0

    def makeSqData(self, right, top, left, bottom):
        for x in range(0, 20):
            for y in range(0, 15):
                flag = self.tiledata[x][y]
                if not self.has(x + 1, y):
                    flag = flag | 1
                if not self.has(x, y - 1):
                    flag = flag | 2
                if not self.has(x - 1, y):
                    flag = flag | 4
                if not self.has(x, y + 1):
                    flag = flag | 8
                self.tiledata[x][y] = flag

        if right is None:
            for y in range(0, 15):
                self.tiledata[19][y] &= 14
        else:
            for y in range(0, 15):
                if right.has(0,y):
                    self.tiledata[19][y] &= 14

        if top is None:
            for x in range(0, 20):
                self.tiledata[x][0] &= 13
        else:
            for x in range(0, 20):
                if top.has(x,14):
                    self.tiledata[x][0] &= 13

        if left is None:
            for y in range(0, 15):
                self.tiledata[0][y] &= 11
        else:
            for y in range(0, 15):
                if left.has(19,y):
                    self.tiledata[0][y] &= 11
        if bottom is None:
            for x in range(0, 20):
                self.tiledata[x][14] &= 7
        else:
            for x in range(0, 20):
                if bottom.has(x,0):
                    self.tiledata[x][14] &= 7


            

    def getCollideMask(self, x, y):
        cX = int(x // 16)
        cY = int(y // 16)
        return self.get_tiledata(cX, cY)

    def generate(self, flag):
        self.spflag = flag
        
        if flag & 1:
            self.addsq(19, 0, 1, 2)
        else:
            self.addsq(19, 0, 1, 15)

        if flag & 2:
            self.addsq(0, 0, 1, 1)
            self.addsq(5, 3, 4, 1)
            self.addsq(12, 4, 4, 1)
            self.addsq(8, 7, 4, 1)
            self.addsq(8, 2, 3, 1)
            self.addsq(3, 10, 2, 1)
        else:
            self.addsq(0, 0, 20, 1)

        if flag & 4:
            self.addsq(0, 0, 1, 2)
        else:
            self.addsq(0, 0, 1, 15)

        if flag & 8:
            self.addsq(0, 14, 2, 1)
            self.addsq(12, 13, 4, 1)
            self.addsq(16, 10, 2, 1)
            self.addsq(9, 11, 2, 1)
            self.addsq(2, 12, 4, 1)
        else:
            self.addsq(0, 14, 20, 1)

    def draw(self):
        surf = pygame.Surface((320, 240), 0, pygame.display.get_surface())
        surf.fill((0, 60, 60))
        for i in range(0, 20):
            for j in range(0, 15):
                if self.tiles[i][j] == 1:
                    surf.blit(self.img.get(self.tiledata[i][j]), (i * 16, j * 16))
        return surf
